---
title: Long Tasks API
slug: Web/API/Long_Tasks_API
tags:
  - API
  - Experimental
  - Landing
  - Long Tasks API
  - NeedsContent
  - Overview
  - Performance
  - PerformanceLongTaskTiming
  - Reference
  - TaskAttributionTiming
  - Web Performance
---
<p>{{DefaultAPISidebar("Long Tasks")}}</p>

<h2 id="Motivation">Motivation</h2>

<p>The experimental Long Tasks API gives us visibility into tasks that take 50 milliseconds or more. The 50 ms threshold comes from the <a href="https://developers.google.com/web/fundamentals/performance/rail">RAIL Model</a>, in particular the <a href="https://developers.google.com/web/fundamentals/performance/rail#response">"Response: process events in under 50 ms"</a> section.</p>

<p>Tasks that block the main thread for 50 ms or more cause, among other issues:</p>

<ul>
 <li>Delayed "{{glossary("Time to interactive")}}".</li>
 <li>High/variable input latency.</li>
 <li>High/variable event handling latency.</li>
 <li>Janky animations and scrolling.</li>
</ul>

<h2 id="Concepts">Concepts</h2>

<p>Some key terms or ideas that are utilized by the Long Tasks API.</p>

<dl>
 <dt>
 <h3 id="Long_task">Long task</h3>
 </dt>
</dl>

<p>Any uninterrupted period where the main UI thread is busy for 50 ms or longer. Common examples include:</p>

<ul>
 <li>Long running event handlers.</li>
 <li>Expensive reflows and other re-renders.</li>
 <li>Work the browser does between different turns of the event loop that exceeds 50 ms.</li>
</ul>

<h3 id="Culprit_browsing_context_container">Culprit browsing context container</h3>

<p>The "culprit browsing context container", or "the container" for short, is the top level page, iframe, embed or object that the task occurred within.</p>

<h3 id="Attributions">Attributions</h3>

<p>A list of containers that the task occurred within. For tasks that don't occur within the top level page, the <code>containerId</code>, <code>containerName</code> and <code>containerSrc</code> fields may provide information as to the source of the task.</p>

<h2 id="Usage">Usage</h2>

<pre class="brush: js">var observer = new PerformanceObserver(function(list) {
    var perfEntries = list.getEntries();
    for (var i = 0; i &lt; perfEntries.length; i++) {
        // Process long task notifications:
        // report back for analytics and monitoring
        // ...
    }
});
// register observer for long task notifications
observer.observe({entryTypes: ["longtask"]});
// Long script execution after this will result in queueing
// and receiving "longtask" entries in the observer.
</pre>

<h2 id="Interfaces">Interfaces</h2>

<dl>
 <dt>{{domxref('PerformanceLongTaskTiming')}}</dt>
 <dd>Reports instances of long tasks.</dd>
 <dt>{{domxref("TaskAttributionTiming")}}</dt>
 <dd>Returns information about the work involved in a long task and its associate frame context.</dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Long Tasks')}}</td>
   <td>{{Spec2('Long Tasks')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<h3 id="PerformanceLongTaskTiming"><code>PerformanceLongTaskTiming</code></h3>

<div>

<p>{{Compat("api.PerformanceLongTaskTiming")}}</p>
</div>

<h3 id="TaskAttributionTiming"><code>TaskAttributionTiming</code></h3>

<div>
<div class="hidden">The compatibility table on this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</div>

<p>{{Compat("api.TaskAttributionTiming")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="https://github.com/w3c/longtasks">GitHub repository</a> contains documentation and some code samples.</li>
 <li><a href="https://calendar.perfplanet.com/2017/tracking-cpu-with-long-tasks-api/">PerfPlanet article</a> on Long Tasks API from 20th December 2017.</li>
</ul>
